<?php
/*

   Copyright 2010 e-WebFace Networks

   Plugin Name: e-WebFace
Plugin URI: http://www.e-webface.com
Version: 1.0
Autor: e-WebFace Networks
Autor URL: http://e-WebFace.com/
Descrição: A e-Webface é um sistema de videoconferência pela web. Este plugin integra a e-Webface com o WordPress permitindo blogueiros criarem e gerenciarem salas de reuniões para interagir com seus leitores para mais informações sobre como configurar o servidor de e-Webface entre em http://www.e-webface.com

Versão 1.0 escrito por Renato Souza Gengo
*/

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Meetings Meeting Model
 */
class MeetingsModelMeeting extends JModel
{
	/**
	 * Constructor that retrieves the id from the request

	 */
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	/**
	 * Method to set the  meeting id
	 */
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * Method to get a meeting
	 * @return object with data
	 */
	function &getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__ewf WHERE id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->meetingName = null;
		}
		return $this->_data;
	}
	
	/**
	 * Method to store a record
	 */
	function store()
	{
		$row =& $this->getTable();
		$data = JRequest::get( 'post' );
		
		//Checks to see if either of them are blank
		if($data['meetingName'] == "" || $data['moderatorPW'] == "" || $data['attendeePW'] == "" ){
			$this->setError("All fields must be filled.");
			return false;
		}
		
		//Makes sure there isn't duplicate meetings.
		$db = JFactory::getDBO();
		$query = "SELECT * FROM #__ewf";
		$db->setQuery($query);
		$list = $db->loadObjectList();

		foreach ($list as $item) {
			if($data['meetingName'] == $item->meetingName){
				$this->setError($item->meetingName." já existe. Por favor escolha um nome diferente.");
				return false;
			}
		}
		
		if($data['waitForModerator'] != 'yes') $data['waitForModerator'] = 'no';
		
		// Bind the form fields to the meeting table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
	 
		// Make sure the meeting record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
	 
		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
	 
		return true;
	}
	
	/**
	 * Method to delete record(s)
	 */
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable();
	 
		foreach($cids as $cid) {
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}
	 
		return true;
	}

}